/*
  Control32Servo.h - Library for controlling Siku Control 32 Servos.
  Created by Oisin O'Conchubhair, November 29, 2015.
  Based on the servoTimer2 library.
  Released into the public domain.
*/

#ifndef Control32Servo_h
#define Control32Servo_h

#include "Arduino.h"

#define NBR_CHANNELS 8                   // the maximum number of channels, don't change this

typedef struct  {
     uint8_t nbr        :5 ;  // a pin number from 0 to 31
     uint8_t isActive   :1 ;  // false if this channel not enabled, pin only pulsed if true
  } Control32_ServoPin_t   ;

typedef struct {
 Control32_ServoPin_t Pin;
 byte Pulsewidth;
}  Control32_Servo_t;

class Control32Servo
{
 public:
     // constructor:
     Control32Servo();

     uint8_t attach(int);     // attach the given pin to the next free channel, sets pinMode, returns channel number or 0 if failure
                              // the attached servo is pulsed with the current pulse width value, (see the write method)
     uint8_t attach(int, int, int); // as above but also sets min and max values for writes.
   void detach();
   void write(int);         // store the pulse width in microseconds (between MIN_PULSE_WIDTH and MAX_PULSE_WIDTH)for this channel
   int read();                    // returns current pulse width in microseconds for this servo
     boolean attached();      // return true if this servo is attached
  	void Pulse(int Pin, int P_Width);
  	  	int _Value;

private:
      uint8_t chanIndex;      // index into the channel data for this servo


};

#endif